#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"

int moveplayer(int thataway, int token) {
  wordnumber++;
  if((!notes[CANTMOVE] && !notes[LAUNCHED]) || testbit(location[position].objects, LAND) || (fuel > 0 && notes[LAUNCHED])) {
    if(thataway) {
      position = thataway;
      newway(token);
      ourtime++;
    } else {
      nprint("You can't go this way.\n");
      newway(token);
      whichway(location[position]);
      return (0);
    }
  } else {
    if(notes[CANTMOVE] && !notes[LAUNCHED]) {
      nprint("You aren't able to move; you better drop\n");
      nprint("something.\n");
    } else {
      nprint("You are out of fuel; now you will rot in\n");
      nprint("space forever!\n");
    }
  }
  return (1);
}

void convert(int tothis) {
  const struct objs *p;
  unsigned int     i, j;

  if(tothis == TONIGHT) {
    for (i = 1; i <= NUMOFROOMS; i++)
      for (j = 0; j < NUMOFWORDS; j++)
        nightfile[i].objects[j] = dayfile[i].objects[j];
    for (p = nightobjs; p->room != 0; p++)
      setbit(nightfile[p->room].objects, p->obj);
    location = nightfile;
  } else {
    for(i = 1; i <= NUMOFROOMS; i++)
      for(j = 0; j < NUMOFWORDS; j++)
        dayfile[i].objects[j] = nightfile[i].objects[j];
    for(p = nightobjs; p->room != 0; p++)
      clearbit(dayfile[p->room].objects, p->obj);
    location = dayfile;
  }
}

void news() {
  int     n;
  int     hurt;
  if(ourtime > 30 && position < 32) {
    nprint("An explosion of shuddering magnitude\n");
    nprint("splinters bulkheads and ruptures the\n");
    nprint("battlestar's hull. You are sucked out\n");
    nprint("into the frozen void of space and\n");
    nprint("killed.\n");
    die();
  }
  if(ourtime > 20 && position < 32)
    nprint("Explosions rock the battlestar.\n");
  if(ourtime > snooze) {
    nprint("You drop from exhaustion...\n");
    zzz();
  }
  if(ourtime > snooze - 5)
    nprint("You're getting tired.\n");
  if(ourtime > (rythmn + CYCLE)) {
    if(location == nightfile) {
      convert(TODAY);
      if(OUTSIDE && ourtime - rythmn - CYCLE < 10) {
        nprint("Dew lit sunbeams stretch out from a\n"); 
        nprint("watery sunrise and herald the dawn. You\n");
        nprint("awake from a misty dream-world into\n");
        nprint("stark reality. It is day.\n");
      }
    } else {
      convert(TONIGHT);
      clearbit(location[POOLS].objects, BATHGOD);
      if(OUTSIDE && ourtime - rythmn - CYCLE < 10) {
        nprint("The dying sun sinks into the ocean,\n"); 
        nprint("leaving a blood-stained sunset. The sky\n");
        nprint("slowly fades from orange to violet to\n");
        nprint("black. A few stars flicker on, and it is\n");
        nprint("night. The world seems completely\n");
        nprint("different at night.\n");
      }
    }
    rythmn = ourtime - ourtime % CYCLE;
  }
  if(!wiz && !tempwiz)
    if((testbit(inven, TALISMAN) || testbit(wear, TALISMAN)) && (testbit(inven, MEDALION) || testbit(wear, MEDALION)) && (testbit(inven, AMULET) || testbit(wear, AMULET))) {
      tempwiz = 1;
      nprint("The three amulets glow and reenforce\n");
      nprint("each other in power. You are now a\n");
      nprint("wizard.\n");
    }
  if(testbit(location[position].objects, ELF)) {
    nprint("%s\n", objdes[ELF]);
    fight(ELF, rnd(30));
  }
  if(testbit(location[position].objects, DARK)) {
    nprint("%s\n", objdes[DARK]);
    fight(DARK, 100);
  }
  if(testbit(location[position].objects, WOODSMAN)) {
    nprint("%s\n", objdes[WOODSMAN]);
    fight(WOODSMAN, 50);
  }
  switch (position) {

  case 267:
  case 257:    /* entering a cave */
  case 274:
  case 246:
    notes[CANTSEE] = 1;
    break;
  case 160:
  case 216:    /* leaving a cave */
  case 230:
  case 231:
  case 232:
    notes[CANTSEE] = 0;
    break;
  }
  if(testbit(location[position].objects, GIRL))
    meetgirl = 1;
  if(meetgirl && CYCLE * 1.5 - ourtime < 10) {
    setbit(location[GARDEN].objects, GIRLTALK);
    setbit(location[GARDEN].objects, LAMPON);
    setbit(location[GARDEN].objects, ROPE);
  }
  if(position == DOCK && (beenthere[position] || ourtime > CYCLE)) {
    clearbit(location[DOCK].objects, GIRL);
    clearbit(location[DOCK].objects, MAN);
  }
  if(meetgirl && ourtime - CYCLE * 1.5 > 10) {
    clearbit(location[GARDEN].objects, GIRLTALK);
    clearbit(location[GARDEN].objects, LAMPON);
    clearbit(location[GARDEN].objects, ROPE);
    meetgirl = 0;
  }
  /*if(testbit(location[position].objects, CYLON)) {
    nprint("Oh my God, you're being shot at by an\n");
        nprint("alien spacecraft!");
    nprint("The targeting computer says we have\n");
        nprint("%d seconds to attack!\n", ourclock);
        nprint("This feature is undeveloped.\n");
    fflush(stdout);
    sleep(1);
    if(!visual()) {
      hurt = rnd(NUMOFINJURIES);
      injuries[hurt] = 1;
      nprint("Laser blasts sear the cockpit, and the\n");
            nprint("alien veers off in a victory roll. The\n");
      nprint("viper shudders under a terrible\n");
            nprint("explosion.\n");
      nprint("I'm afraid you have suffered %s.\n", ouch[hurt]);
    } else
      clearbit(location[position].objects, CYLON);
  }*/
  if(injuries[SKULL] && injuries[INCISE] && injuries[NECK]) {
    nprint("I'm afraid you have suffered fatal\n");
    nprint("injuries.\n");
    die();
  }
  for (n = 0; n < NUMOFINJURIES; n++)
    if(injuries[n] == 1) {
      injuries[n] = 2;
      if(WEIGHT > 5)
        WEIGHT -= 5;
      else
        WEIGHT = 0;
    }
  if(injuries[ARM] == 2) {
    if(CUMBER > 5)
      CUMBER -= 5;
    else
      CUMBER = 0;
    injuries[ARM]++;
  }
  if(injuries[RIBS] == 2) {
    if(CUMBER > 2)
      CUMBER -= 2;
    else
      CUMBER = 0;
    injuries[RIBS]++;
  }
  if(injuries[SPINE] == 2) {
    WEIGHT = 0;
    injuries[SPINE]++;
  }
  if(carrying > WEIGHT || encumber > CUMBER)
    notes[CANTMOVE] = 1;
  else
    notes[CANTMOVE] = 0;
}

void crash() {
  int     hurt1, hurt2;

  fuel--;
  if(!location[position].flyhere || (testbit(location[position].objects, LAND) && fuel <= 0)) {
    if(!location[position].flyhere) {
      nprint("You're flying too low.\n");
      nprint("We're going to crash!\n");
    } else {
      nprint("You're out of fuel.\n");
      nprint("We'll have to crash land!\n");
      if(!location[position].down) {
        nprint("Your viper strikes the ground and\n");
        nprint("explodes into fiery fragments. Thick\n");
        nprint("Thick black smoke billows up from the\n");
        nprint("wreckage.");
        die();
      }
      position = location[position].down;
    }
    notes[LAUNCHED] = 0;
    setbit(location[position].objects, CRASH);
    ourtime += rnd(CYCLE / 4);
    nprint("The viper explodes into the ground and\n");
    nprint("you lose consciousness...\n");
    zzz();
    hurt1 = rnd(NUMOFINJURIES - 2) + 2;
    hurt2 = rnd(NUMOFINJURIES - 2) + 2;
    injuries[hurt1] = 1;
    injuries[hurt2] = 1;
    injuries[0] = 1;/* abrasions */
    injuries[1] = 1;/* lacerations */
    nprint("I'm afraid you have suffered %s\n", ouch[hurt1]);
    nprint("and %s.\n", ouch[hurt2]);
  }
}
