#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"


int wearit() {
  int firstnumber, value;

  firstnumber = wordnumber;
  wordnumber++;
  while (wordnumber <= wordcount && (wordtype[wordnumber] == OBJECT || wordtype[wordnumber] == NOUNS) && wordvalue[wordnumber] != DOOR) {
    value = wordvalue[wordnumber];
    if(value >= 0 && objsht[value] == NULL)
      break;
    switch (value) {
      case -1:
        nprint("Wear what?\n");
        return (firstnumber);
      default:
        nprint("You can't wear %s%s!\n", A_OR_AN_OR_BLANK(value), objsht[value]);
        return (firstnumber);
      case KNIFE:
      case ROBE:
      case LEVIS:
      case SWORD:
      case MAIL:
      case HELM:
      case SHOES:
      case PAJAMAS:
      case COMPASS:
      case LASER:
      case AMULET:
      case TALISMAN:
      case MEDALION:
      case ROPE:
      case RING:
      case BRACELET:
      case GRENADE:
        if(testbit(inven, value)) {
          clearbit(inven, value);
          setbit(wear, value);
          carrying -= objwt[value];
          encumber -= objcumber[value];
          ourtime++;
          nprint("You are now wearing %s%s.\n", A_OR_AN_OR_THE(value), objsht[value]);
        } else
          if(testbit(wear, value))
            nprint("You are already wearing the %s.\n", objsht[value]);
          else
            nprint("You aren't holding the %s.\n", objsht[value]);
        if(wordnumber < wordcount - 1 && wordvalue[++wordnumber] == AND)
          wordnumber++;
        else
          return (firstnumber);
    }
  }
  nprint("Don't be ridiculous.\n");
  return (firstnumber);
}

int put() {
  if(wordvalue[wordnumber + 1] == ON) {
    wordvalue[++wordnumber] = PUTON;
    wordtype[wordnumber] = VERB;
    return (cypher());
  }
  if(wordvalue[wordnumber + 1] == DOWN) {
    wordvalue[++wordnumber] = DROP;
    wordtype[wordnumber] = VERB;
    return (cypher());
  }
  nprint("I don't understand what you want to put.\n");
  return (-1);
}

int draw() {
  return (take(wear));
}

int use() {
  wordnumber++;
  if(wordvalue[wordnumber] == AMULET && testbit(inven, AMULET) && position != FINAL) {
    nprint("The amulet begins to glow.\n");
    if(testbit(inven, MEDALION)) {
      nprint("The medallion comes to life too.\n");
      if(position == 114) {
        location[position].down = 160;
        whichway(location[position]);
        nprint("The waves subside and it is possible\n");
        nprint("to descend to the sea cave now.\n");
        ourtime++;
        return (-1);
      }
    }
    nprint("A light mist falls over your eyes and\n");
    nprint("the sound of purling water trickles in\n");
    nprint("your ears. When the mist lifts you are\n");
    nprint("standing beside a cool stream.\n");
    if(position == 229)
      position = 224;
    else
      position = 229;
    ourtime++;
    notes[CANTSEE] = 0;
    return (0);
  } else if(position == FINAL)
    nprint("The amulet won't work in here.\n");
  else if(wordvalue[wordnumber] == COMPASS && testbit(inven, COMPASS))
    nprint("Your compass points %s.\n", truedirec(NORTH, '-'));
  else if(wordvalue[wordnumber] == COMPASS)
    nprint("You aren't holding the compass.\n");
  else if(wordvalue[wordnumber] == AMULET)
    nprint("You aren't holding the amulet.\n");
  else
    nprint("There is no apparent use.\n");
  return (-1);
}

void murder() {
  int n;

  for (n = 0; !((n == SWORD || n == KNIFE || n == TWO_HANDED || n == MACE || n == CLEAVER || n == BROAD || n == CHAIN || n == SHOVEL || n == HALBERD) && testbit(inven, n)) && n < NUMOFOBJECTS; n++);
    if(n == NUMOFOBJECTS) {
      if(testbit(inven, LASER)) {
        nprint("Your laser should do the trick.\n");
        wordnumber++;
        switch(wordvalue[wordnumber]) {
          case NORMGOD:
          case TIMER:
          case NATIVE:
          case MAN:
            wordvalue[--wordnumber] = SHOOT;
            cypher();
            break;
          case -1:
            nprint("Kill what?\n");
            break;
          default:
            if(wordtype[wordnumber] != OBJECT || wordvalue[wordnumber] == EVERYTHING)
              nprint("You can't kill that!\n");
            else
              nprint("You can't kill %s%s!\n", A_OR_AN_OR_BLANK(wordvalue[wordnumber]), objsht[wordvalue[wordnumber]]);
            break;
        }
      } else
        nprint("You don't have suitable weapons to kill.\n");
    } else {
      nprint("Your %s should do the trick.\n", objsht[n]);
      wordnumber++;
      switch (wordvalue[wordnumber]) {
        case NORMGOD:
          if(testbit(location[position].objects, BATHGOD)) {
            nprint("The goddess's head slices off. Her\n");
            nprint("corpse floats in the water.\n");
            clearbit(location[position].objects, BATHGOD);
            setbit(location[position].objects, DEADGOD);
            power += 5;
            notes[JINXED]++;
          } else if(testbit(location[position].objects, NORMGOD)) {
            nprint("The goddess pleads but you strike her\n");
            nprint("mercilessly. Her broken body lies in a\n");
            nprint("pool of blood.\n");
            clearbit(location[position].objects, NORMGOD);
            setbit(location[position].objects, DEADGOD);
            power += 5;
            notes[JINXED]++;
            if(wintime) live();
          } else
            nprint("I don't see her anywhere.\n");
          break;
        case TIMER:
          if(testbit(location[position].objects, TIMER)) {
            nprint("The old man offers no resistance.\n");
            clearbit(location[position].objects, TIMER);
            setbit(location[position].objects, DEADTIME);
            power++;
            notes[JINXED]++;
          } else
            nprint("Who?\n");
          break;
        case NATIVE:
          if(testbit(location[position].objects, NATIVE)) {
            nprint("The girl screams as you cut her body to\n");
            nprint("shreds. She is dead.\n");
            clearbit(location[position].objects, NATIVE);
            setbit(location[position].objects, DEADNATIVE);
            power += 5;
            notes[JINXED]++;
          } else
            nprint("What girl?\n");
          break;
        case MAN:
          if(testbit(location[position].objects, MAN)) {
            nprint("You strike him to the ground, and he\n");
            nprint("coughs up blood. Your fantasy is over.\n");
            die();
          }
        case -1:
          nprint("Kill what?\n");
          break;
        default:
          if(wordtype[wordnumber] != OBJECT || wordvalue[wordnumber] == EVERYTHING)
            nprint("You can't kill that!\n");
          else
            nprint("You can't kill the %s!\n",
            objsht[wordvalue[wordnumber]]);
    }
  }
}

void ravage() {
  while (wordtype[++wordnumber] != NOUNS && wordnumber <= wordcount)
    continue;
  if(wordtype[wordnumber] == NOUNS && (testbit(location[position].objects, wordvalue[wordnumber]) || (wordvalue[wordnumber] == NORMGOD && testbit(location[position].objects, BATHGOD)))) {
    ourtime++;
    switch (wordvalue[wordnumber]) {
      case NORMGOD:
        nprint("You attack the goddess, and she screams\n");
        nprint("as you beat her. She falls down crying\n");
        if(testbit(location[position].objects, BATHGOD))
          nprint("and tries to cover her nakedness.\n");
        else
          nprint("and tries to hold her torn and bloodied\n");
          nprint("dress around her.\n");
        power += 5;
        pleasure += 8;
        ego -= 10;
        wordnumber--;
        godready = -30000;
        murder();
        win = -30000;
        break;
      case NATIVE:
        nprint("The girl tries to run, but you catch her\n");
        nprint("and throw her down. Her face is bleeding\n");
        nprint("and she screams as you tear off her\n");
        nprint("clothes.\n");
        power += 3;
        pleasure += 5;
        ego -= 10;
        wordnumber--;
        murder();
        if(rnd(100) < 50) {
          nprint("Her screams have attracted attention. I\n");
          nprint("think we are surrounded.\n");
          setbit(location[ahead].objects, WOODSMAN);
          setbit(location[ahead].objects, DEADWOOD);
          setbit(location[ahead].objects, MALLET);
          setbit(location[back].objects, WOODSMAN);
          setbit(location[back].objects, DEADWOOD);
          setbit(location[back].objects, MALLET);
          setbit(location[left].objects, WOODSMAN);
          setbit(location[left].objects, DEADWOOD);
          setbit(location[left].objects, MALLET);
          setbit(location[right].objects, WOODSMAN);
          setbit(location[right].objects, DEADWOOD);
          setbit(location[right].objects, MALLET);
        }
        break;
      default:
        nprint("You are perverted.\n");
    }
  } else
    nprint("Who?\n");
}

int follow() {
  if(followfight == ourtime) {
    nprint("The Dark Lord leaps away and runs down\n");
    nprint("secret tunnels and corridors. You chase\n");
    nprint("him through the darkness and splash in\n");
    nprint("pools of water. You have cornered him.\n");
    nprint("His laser sword extends as he steps\n");
    nprint("forward.\n");
    position = FINAL;
    fight(DARK, 75);
    setbit(location[position].objects, TALISMAN);
    setbit(location[position].objects, AMULET);
    return (0);
  } else
    if(followgod == ourtime) {
      nprint("The goddess leads you down a steamy\n");
      nprint("tunnel and into a high, wide chamber.\n");
      nprint("She sits down on a throne.\n");
      position = 268;
      setbit(location[position].objects, NORMGOD);
      notes[CANTSEE] = 1;
      return (0);
    } else
      nprint("There is no one to follow.\n");
  return (-1);
}
