#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"


void dig() {
  if(testbit(inven, SHOVEL)) {
    nprint("OK\n");
    ourtime++;
    switch (position) {
      case 144:  /* copse near beach */
        if(!notes[DUG]) {
          setbit(location[position].objects, DEADWOOD);
          setbit(location[position].objects, COMPASS);
          setbit(location[position].objects, KNIFE);
          setbit(location[position].objects, MACE);
          notes[DUG] = 1;
        }
        break;
      default:
        nprint("Nothing happens\n");
    }
  } else
    nprint("You don't have a shovel.\n");
}

int jump() {
  int n;

  switch (position) {
    default:
      nprint("Nothing happens.\n");
      return (-1);
    case 242:
      position = 133;
      break;
    case 214:
    case 215:
    case 162:
    case 159:
      position = 145;
      break;
    case 232:
      position = FINAL;
      break;
    case 3:
      position = 1;
      break;
    case 172:
      position = 201;
  }
  nprint("Ahhhhhhh...\n");
  injuries[12] = injuries[8] = injuries[7] = injuries[6] = 1;
  for (n = 0; n < NUMOFOBJECTS; n++)
    if(testbit(inven, n)) {
      clearbit(inven, n);
      setbit(location[position].objects, n);
    }
  carrying = 0;
  encumber = 0;
  return (0);
}

void bury() {
  int value;

  if(testbit(inven, SHOVEL)) {
    while (wordtype[++wordnumber] != OBJECT && wordtype[wordnumber] != NOUNS && wordnumber < wordcount)
      continue;
    value = wordvalue[wordnumber];
    if(wordtype[wordnumber] == NOUNS && (testbit(location[position].objects, value) || value == BODY))
      switch (value) {
        case BODY:
          wordtype[wordnumber] = OBJECT;
          if(testbit(inven, MAID) || testbit(location[position].objects, MAID))
            value = MAID;
          if(testbit(inven, DEADWOOD) || testbit(location[position].objects, DEADWOOD))
            value = DEADWOOD;
          if(testbit(inven, DEADGOD) || testbit(location[position].objects, DEADGOD))
            value = DEADGOD;
          if(testbit(inven, DEADTIME) || testbit(location[position].objects, DEADTIME))
            value = DEADTIME;
          if(testbit(inven, DEADNATIVE) || testbit(location[position].objects, DEADNATIVE))
            value = DEADNATIVE;
          break;
        case NATIVE:
        case NORMGOD:
          nprint("She screams as you wrestle her into the\n");
          nprint("hole.\n");
        case TIMER:
          power += 7;
          ego -= 10;
        case AMULET:
        case MEDALION:
        case TALISMAN:
          wordtype[wordnumber] = OBJECT;
          break;

        default:
          nprint("Wha..?\n");
      }
    if(wordtype[wordnumber] == OBJECT && position > 88 && (testbit(inven, value) || testbit(location[position].objects, value))) {
      nprint("Buried.\n");
      if(testbit(inven, value)) {
        clearbit(inven, value);
        carrying -= objwt[value];
        encumber -= objcumber[value];
      }
      clearbit(location[position].objects, value);
      switch (value) {
        case MAID:
        case DEADWOOD:
        case DEADNATIVE:
        case DEADTIME:
        case DEADGOD:
          ego += 2;
          nprint("The %s should rest easier now.\n", objsht[value]);
      }
    } else
      nprint("It doesn't seem to work.\n");
  } else
    nprint("You aren't holding a shovel.\n");
}

void drink() {
  int n;

  if(testbit(inven, POTION)) {
    nprint("The cool liquid runs down your throat\n");
    nprint("but turns to fire and you choke. The\n");
    nprint("heat reaches your limbs and tingles your\n");
    nprint("spirit. You feel like falling asleep.\n");
    clearbit(inven, POTION);
    WEIGHT = MAXWEIGHT;
    CUMBER = MAXCUMBER;
    for (n = 0; n < NUMOFINJURIES; n++)
      injuries[n] = 0;
    ourtime++;
    zzz();
  } else
    nprint("I'm not thirsty.\n");
}

int shoot() {
  int firstnumber, value;

  firstnumber = wordnumber;
  if(!testbit(inven, LASER))
    nprint("You aren't holding a blaster.\n");
  else {
    wordnumber++;
    while (wordnumber <= wordcount && wordtype[wordnumber] == OBJECT) {
      value = wordvalue[wordnumber];
      nprint("%s:\n", objsht[value]);
      if(testbit(location[position].objects, value)) {
        clearbit(location[position].objects, value);
        ourtime++;
        nprint("The %s explode%s\n", objsht[value], (is_plural_object(value) ? "." : "s."));
        if(value == BOMB)
          die();
      } else
        nprint("I don't see any %s around here.\n", objsht[value]);
      if(wordnumber < wordcount - 1 && wordvalue[++wordnumber] == AND)
        wordnumber++;
      else
        return (firstnumber);
    }
    /* special cases with their own return()'s */

    if(wordnumber <= wordcount && wordtype[wordnumber] == NOUNS) {
      ourtime++;
      switch (wordvalue[wordnumber]) {
        case DOOR:
          switch (position) {
            case 189:
            case 231:
              nprint("The door is unhinged.\n");
              location[189].north = 231;
              location[231].south = 189;
              whichway(location[position]);
              break;
            case 30:
              nprint("The wooden door splinters.\n");
              location[30].west = 25;
              whichway(location[position]);
              break;
            case 31:
              nprint("The laser blast has no effect on the\n");
              nprint("door.\n");
              break;
            case 20:
              nprint("The blast hits the door and it explodes\n");
              nprint("into flame. The magnesium burns so\n");
              nprint("rapidly that we have no chance to\n");
              nprint("escape.\n");
              die();
            default:
              nprint("Nothing happens.\n");
          }
          break;
        case NORMGOD:
          if(testbit(location[position].objects, BATHGOD)) {
            nprint("The goddess is hit in the chest and\n");
            nprint("splashes back against the rocks. Dark\n");
            nprint("blood oozes from the charred blast hole.\n");
            nprint("Her naked body floats in the pools and\n");
            nprint("then off downstream.\n");
            clearbit(location[position].objects, BATHGOD);
            setbit(location[180].objects, DEADGOD);
            power += 5;
            ego -= 10;
            notes[JINXED]++;
          } else
            if(testbit(location[position].objects, NORMGOD)) {
              nprint("The blast catches the goddess in the\n");
              nprint("stomach, knocking her to the ground. She\n");
              nprint("writhes in the dirt as the agony of\n");
              nprint("death taunts her. She has stopped\n");
              nprint("moving.\n");
              clearbit(location[position].objects, NORMGOD);
              setbit(location[position].objects, DEADGOD);
              power += 5;
              ego -= 10;
              notes[JINXED]++;
              if(wintime) live();
              break;
            } else
              nprint("I don't see any goddess around here.\n");
          break;
        case TIMER:
          if(testbit(location[position].objects, TIMER)) {
            nprint("The old man slumps over the bar.\n");
            power++;
            ego -= 2;
            notes[JINXED]++;
            clearbit(location[position].objects, TIMER);
            setbit(location[position].objects, DEADTIME);
          } else
            nprint("What old-timer?\n");
          break;
        case MAN:
          if(testbit(location[position].objects, MAN)) {
            nprint("The man falls to the ground with blood\n");
            nprint("pouring all over his white suit.\n");
            nprint("Your fantasy is over.\n");
            die();
          } else
            nprint("What man?\n");
          break;
        case NATIVE:
          if(testbit(location[position].objects, NATIVE)) {
            nprint("The girl is blown backwards several feet\n");
            nprint("and lies in a pool of blood.\n");
            clearbit(location[position].objects, NATIVE);
            setbit(location[position].objects, DEADNATIVE);
            power += 5;
            ego -= 2;
            notes[JINXED]++;
          } else
            nprint("There is no girl here.\n");
          break;
        case -1:
          nprint("Shoot what?\n");
          break;
        default:
          nprint("You can't shoot the %s.\n", objsht[wordvalue[wordnumber]]);
      }
    } else
      nprint("You must be a looney.\n");
  }
  return (firstnumber);
}
