#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"


int take(unsigned int from[]) {
  int firstnumber, heavy, bulky, value;

  firstnumber = wordnumber;
  if(wordnumber < wordcount && wordvalue[wordnumber + 1] == OFF) {
    wordnumber++;
    wordvalue[wordnumber] = TAKEOFF;
    wordtype[wordnumber] = VERB;
    return (cypher());
  } else {
    wordnumber++;
    while (wordnumber <= wordcount && wordtype[wordnumber] == OBJECT) {
      value = wordvalue[wordnumber];
      nprint("%s:\n", objsht[value]);
      heavy = (carrying + objwt[value]) <= WEIGHT;
      bulky = (encumber + objcumber[value]) <= CUMBER;
      if((testbit(from, value) || wiz || tempwiz) && heavy && bulky && !testbit(inven, value)) {
        setbit(inven, value);
        carrying += objwt[value];
        encumber += objcumber[value];
        ourtime++;
        if(testbit(from, value))
          nprint("Taken.\n");
        else
          nprint("Zap! Taken from thin air.\n");
        clearbit(from, value);
        if(value == MEDALION)
          win--; //WTF?!
      } else if(testbit(inven, value))
        nprint("You're already holding %s%s.\n", A_OR_AN_OR_BLANK(value), objsht[value]);
      else if(!testbit(from, value))
        nprint("I don't see any %s around here.\n", objsht[value]);
      else if(!heavy)
        nprint("The %s %stoo heavy.\n", objsht[value], IS_OR_ARE(value));
      else
        nprint("The %s %stoo cumbersome to hold.\n", objsht[value], IS_OR_ARE(value));
      if(wordnumber < wordcount - 1 && wordvalue[++wordnumber] == AND)
        wordnumber++;
      else
        return (firstnumber);
    }
  }
  /* special cases with their own return()'s */

  if(wordnumber <= wordcount && wordtype[wordnumber] == NOUNS)
    switch (wordvalue[wordnumber]) {
      case SWORD:
        if(testbit(from, SWORD)) {
          wordtype[wordnumber--] = OBJECT;
          return (take(from));
        }
        if(testbit(from, TWO_HANDED)) {
          wordvalue[wordnumber] = TWO_HANDED;
          wordtype[wordnumber--] = OBJECT;
          return (take(from));
        }
        wordvalue[wordnumber] = BROAD;
        wordtype[wordnumber--] = OBJECT;
        return (take(from));
      case BODY:
        if(testbit(from, MAID)) {
          wordvalue[wordnumber] = MAID;
          wordtype[wordnumber--] = OBJECT;
          return (take(from));
        } else if(testbit(from, DEADWOOD)) {
          wordvalue[wordnumber] = DEADWOOD;
          wordtype[wordnumber--] = OBJECT;
          return (take(from));
        } else if(testbit(from, DEADNATIVE)) {
          wordvalue[wordnumber] = DEADNATIVE;
          wordtype[wordnumber--] = OBJECT;
          return (take(from));
        } else {
          if(testbit(from, DEADGOD)) {
            wordvalue[wordnumber] = DEADGOD;
            wordtype[wordnumber--] = OBJECT;
            return (take(from));
          } else {
            wordvalue[wordnumber] = DEADTIME;
            wordtype[wordnumber--] = OBJECT;
            return (take(from));
          }
        }
        break;
      case AMULET:
        if(testbit(location[position].objects, AMULET)) {
          nprint("The amulet is warm to the touch, and its\n");
          nprint("beauty catches your breath. A mist falls\n");
          nprint("over your eyes, but then it is gone.\n");
          nprint("Sounds seem clearer and sharper but far\n");
          nprint("away as if in a dream. The sound of\n");
          nprint("purling water reaches you from afar. The\n");
          nprint("mist falls again, and your heart leaps\n");
          nprint("in horror. The gold freezes your hands\n");
          nprint("and fathomless darkness engulfs your\n");
          nprint("soul\n");
        }
        wordtype[wordnumber--] = OBJECT;
        return (take(from));
      case MEDALION:
        if(testbit(location[position].objects, MEDALION)) {
          nprint("The medallion is warm, and it rekindles\n"); 
          nprint("your spirit with the warmth of life.\n");
          nprint("Your amulet begins to glow as the\n");
          nprint("medallion is brought near to it, and\n");
          nprint("together they radiate.\n");
        }
        wordtype[wordnumber--] = OBJECT;
        return (take(from));
      case TALISMAN:
        if(testbit(location[position].objects, TALISMAN)) {
          nprint("The talisman is cold to the touch, and\n");
          nprint("it sends a chill down your spine\n");
        }
        wordtype[wordnumber--] = OBJECT;
        return (take(from));
      case NORMGOD:
        if(testbit(location[position].objects, BATHGOD) && (testbit(wear, AMULET) || testbit(inven, AMULET))) {
          nprint("She offers a delicate hand, and you help\n");
          nprint("her out of the sparkling springs. Water\n");
          nprint("droplets like liquid silver bedew her\n");
          nprint("golden skin, but when they part from\n");
          nprint("her, they fall as teardrops. She wraps a\n");
          nprint("single cloth around her and ties it at\n");
          nprint("the waist. Around her neck hangs a\n");
          nprint("golden amulet. She bids you to follow\n");
          nprint("her, and walks away.\n");
          pleasure++;
          followgod = ourtime;
          clearbit(location[position].objects, BATHGOD);
        } else
          if(!testbit(location[position].objects, BATHGOD))
            nprint("You're in no position to take her.\n");
          else
            nprint("She moves away from you.\n");
        break;
      default:
        nprint("It doesn't seem to work.\n");
    }
  else
    nprint("You've got to be kidding.\n");
  return (firstnumber);
}

int throw(const char *name) {
  unsigned int n;
  int deposit = 0;
  int first, value;

  first = wordnumber;
  if(drop(name) != -1) {
    switch (wordvalue[wordnumber]) {
      case AHEAD:
        deposit = ahead;
        break;
      case BACK:
        deposit = back;
        break;
      case LEFT:
        deposit = left;
        break;
      case RIGHT:
        deposit = right;
        break;
      case UP:
        deposit = location[position].up * (location[position].access || position == FINAL);
        break;
      case DOWN:
        deposit = location[position].down;
        break;
    }
    wordnumber = first + 1;
    while (wordnumber <= wordcount) {
      value = wordvalue[wordnumber];
      if(deposit && testbit(location[position].objects, value)) {
        clearbit(location[position].objects, value);
        if(value != GRENADE)
          setbit(location[deposit].objects, value);
        else {
          nprint("A thundering explosion nearby sends up a\n");
          nprint("cloud of smoke and shrapnel.\n");
          for (n = 0; n < NUMOFWORDS; n++)
            location[deposit].objects[n] = 0;
          setbit(location[deposit].objects, CHAR);
        }
        if(value == ROPE && position == FINAL)
          location[position].access = 1;
        switch (deposit) {
          case 189:
          case 231:
            nprint("The stone door is unhinged.\n");
            location[189].north = 231;
            location[231].south = 189;
            break;
          case 30:
            nprint("The wooden door is blown open.\n");
            location[30].west = 25;
            break;
          case 31:
            nprint("The door is not damaged.\n");
        }
      } else
        if(value == GRENADE && testbit(location[position].objects, value)) {
          nprint("You are blown into shreds when your\n");
          nprint("grenade explodes.\n");
          die();
        }
      if(wordnumber < wordcount - 1 && wordvalue[++wordnumber] == AND)
        wordnumber++;
      else
        return (first);
    }
    return (first);
  }
  return (first);
}

int drop(const char *name) {
  int firstnumber, value;

  firstnumber = wordnumber;
  wordnumber++;
  while (wordnumber <= wordcount && (wordtype[wordnumber] == OBJECT || wordtype[wordnumber] == NOUNS)) {
    value = wordvalue[wordnumber];
    if(value == BODY) {  /* special case */
      wordtype[wordnumber] = OBJECT;
      if(testbit(inven, MAID) || testbit(location[position].objects, MAID))
        value = MAID;
      else if(testbit(inven, DEADWOOD) || testbit(location[position].objects, DEADWOOD))
        value = DEADWOOD;
      else if(testbit(inven, DEADGOD) || testbit(location[position].objects, DEADGOD))
        value = DEADGOD;
      else if(testbit(inven, DEADTIME) || testbit(location[position].objects, DEADTIME))
        value = DEADTIME;
      else if(testbit(inven, DEADNATIVE) || testbit(location[position].objects, DEADNATIVE))
        value = DEADNATIVE;
    }
    if(wordtype[wordnumber] == NOUNS && value == DOOR) {
      if(*name == 'K')
        nprint("You hurt your foot.\n");
      else
        nprint("You're not holding a door.\n");
    } else if(objsht[value] == NULL) {
      if(*name == 'K')
        nprint("That's not for kicking!\n");
      else
        nprint("You don't have that.\n");
    } else {
      nprint("%s:\n", objsht[value]);
      if(testbit(inven, value)) {
        clearbit(inven, value);
        carrying -= objwt[value];
        encumber -= objcumber[value];
        if(value == BOMB) {
          nprint("The bomb explodes. A blinding white\n");
          nprint("light and immense concussion obliterate\n");
          nprint("us.\n");
          die();
        }
        if(value != AMULET && value != MEDALION && value != TALISMAN)
          setbit(location[position].objects, value);
        else
          tempwiz = 0;
        ourtime++;
        if(*name == 'K')
          nprint("Drop kicked.\n");
        else
          nprint("%s.\n", name);
      } else {
        if(*name != 'K') {
          nprint("You aren't holding the %s.\n", objsht[value]);
          if(testbit(location[position].objects, value)) {
            if(*name == 'T')
              nprint("Kicked instead.\n");
            else if(*name == 'G')
              nprint("Given anyway.\n");
          }
        } else if(testbit(location[position].objects, value))
          nprint("Kicked.\n");
        else if(testbit(wear, value))
          nprint("Not while it's being worn.\n");
        else
          nprint("Not found.\n");
      }
    }
    if(wordnumber < wordcount - 1 && wordvalue[++wordnumber] == AND)
      wordnumber++;
    else
      return (firstnumber);
  }
  nprint("Do what?\n");
  return (-1);
}

int takeoff() {
  wordnumber = take(wear);
  return (drop("Dropped"));
}

int puton()
{
  wordnumber = take(location[position].objects);
  return (wearit());
}

int eat() {
  int firstnumber, value;

  firstnumber = wordnumber;
  wordnumber++;
  while (wordnumber <= wordcount) {
    value = wordvalue[wordnumber];
    if(wordtype[wordnumber] != OBJECT || objsht[value] == NULL)
      value = -2;
    switch (value) {
      case -2:
        nprint("You can't eat that!\n");
        return (firstnumber);
      case -1:
        nprint("Eat what?\n");
        return (firstnumber);
      default:
        nprint("You can't eat %s%s!\n",  A_OR_AN_OR_BLANK(value), objsht[value]);
        return (firstnumber);
      case PAPAYAS:
      case PINEAPPLE:
      case KIWI:
      case COCONUTS:  /* eatable things */
      case MANGO:
        nprint("%s:\n", objsht[value]);
        if(testbit(inven, value) && ourtime > ate - CYCLE && testbit(inven, KNIFE)) {
          clearbit(inven, value);
          carrying -= objwt[value];
          encumber -= objcumber[value];
          ate = max(ourtime, ate) + CYCLE / 3;
          snooze += CYCLE / 10;
          ourtime++;
          nprint("Eaten. You can explore a little longer\n");
          nprint("now.\n");
        } else if(!testbit(inven, value))
          nprint("You aren't holding the %s.\n", objsht[value]);
        else if(!testbit(inven, KNIFE))
          nprint("You need a knife.\n");
        else
          nprint("You're stuffed.\n");
        if(wordnumber < wordcount - 1 && wordvalue[++wordnumber] == AND)
          wordnumber++;
        else
          return (firstnumber);
    }    /* end switch */
  }      /* end while */
  return (firstnumber);
}
