#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"


int launch() {
  if(testbit(location[position].objects, VIPER) && !notes[CANTLAUNCH]) {
    if(fuel > 4) {
      clearbit(location[position].objects, VIPER);
      position = location[position].up;
      notes[LAUNCHED] = 1;
      ourtime++;
      fuel -= 4;
      nprint("You climb into the viper and prepare for\n");
      nprint("launch. With a touch of your thumb the\n");
      nprint("turbo engines ignite, thrusting you back\n");
      nprint("into your seat.\n");
      return (1);
    } else
      nprint("Not enough fuel to launch.\n");
  } else
    nprint("Can't launch.\n");
  return (0);
}

int land() {
  if(notes[LAUNCHED] && testbit(location[position].objects, LAND) && location[position].down) {
    notes[LAUNCHED] = 0;
    position = location[position].down;
    setbit(location[position].objects, VIPER);
    fuel -= 2;
    ourtime++;
    nprint("You are down.\n");
    return (1);
  } else
    nprint("You can't land here.\n");
  return (0);
}

void die() {        /* endgame */
  nprint("bye.\nYour rating was %s.\n", rate());
  //post(' ');
}

void diesig(int dummy) {
  die();
}

void live() {
  nprint("\nYou win!\nYour rating was %s.\n", rate());
  //post('!');
}

static FILE *score_fp;

/*void
open_score_file()
{
  score_fp = fopen(_PATH_SCORE, "a");
  if(score_fp == NULL && getenv("BATTLESTAR_QUIET") == NULL)
    warn("open %s for append", _PATH_SCORE);
  if(score_fp != NULL && fileno(score_fp) < 3)
    exit(1);
}

void
post(ch)
  char    ch;
{
  time_t tv;
  char   *date;
  sigset_t sigset, osigset;

  sigemptyset(&sigset);
  sigaddset(&sigset, SIGINT);
  sigprocmask(SIG_BLOCK, &sigset, &osigset);
  tv = time(NULL);
  date = ctime(&tv);
  date[24] = '\0';
  if(score_fp != NULL) {
    fprintf(score_fp, "%s  %8s  %c%20s", date, username, ch, rate());
    if(wiz)
      fprintf(score_fp, "   wizard\n");
    else
      if(tempwiz)
        fprintf(score_fp, "   WIZARD!\n");
      else
        fprintf(score_fp, "\n");
  }
  sigprocmask(SIG_SETMASK, &osigset, (sigset_t *) 0);
}*/

const char *rate() {
  int score;

  score = max(max(pleasure, power), ego);
  if(score == pleasure) {
    if(score < 5)
      return ("novice");
    else if(score < 20)
      return ("junior voyeur");
    else if(score < 35)
      return ("Don Juan");
    else
      return ("Marquis De Sade");
  } else if(score == power) {
    if(score < 5)
      return ("serf");
    else if(score < 8)
      return ("Samurai");
    else if(score < 13)
      return ("Klingon");
    else if(score < 22)
      return ("Darth Vader");
    else
      return ("Sauron the Great");
  } else {
    if(score < 5)
      return ("Polyanna");
    else if(score < 10)
      return ("philanthropist");
    else if(score < 20)
      return ("Tattoo");
    else
      return ("Mr. Roarke");
  }
}

int drive() {
  if(testbit(location[position].objects, CAR)) {
    nprint("You hop in the car and turn the key.\n");
    nprint("There is a perceptible grating noise,\n");
    nprint("and an explosion knocks you\n");
    

nprint("unconscious...\n");
    clearbit(location[position].objects, CAR);
    setbit(location[position].objects, CRASH);
    injuries[5] = injuries[6] = injuries[7] = injuries[8] = 1;
    ourtime += 15;
    zzz();
    return (0);
  } else
    nprint("There is nothing to drive here.\n");
  return (-1);
}

int ride() {
  if(testbit(location[position].objects, HORSE)) {
    nprint("You climb onto the stallion and kick it\n");
    nprint("in the guts. The stupid steed launches\n");
    nprint("forward through bush and fern. You are\n");
    nprint("thrown and the horse gallops off.\n");
    clearbit(location[position].objects, HORSE);
    while (!(position = rnd(NUMOFROOMS + 1)) || !OUTSIDE || !beenthere[position] || location[position].flyhere)
      continue;
    setbit(location[position].objects, HORSE);
    if(location[position].north)
      position = location[position].north;
    else if(location[position].south)
      position = location[position].south;
    else if(location[position].east)
      position = location[position].east;
    else
      position = location[position].west;
    return (0);
  } else
    nprint("There is no horse here.\n");
  return (-1);
}

void light() {
  if(testbit(inven, MATCHES) && matchcount) {
    nprint("Your match splutters to life.\n");
    ourtime++;
    matchlight = 1;
    matchcount--;
    if(position == 217) {
      nprint("The whole bungalow explodes with an\n");
      nprint("intense blast.\n");
      die();
    }
  } else
    nprint("You're out of matches.\n");
}

void dooropen() {        /* synonyms = {open, unlock} */
  wordnumber++;
  if(wordnumber <= wordcount && wordtype[wordnumber] == NOUNS && wordvalue[wordnumber] == DOOR) {
    switch(position) {
      case 189:
      case 231:
        if(location[189].north == 231)
          nprint("The door is already open.\n");
        else
          nprint("The door does not budge.\n");
        break;
      case 30:
        if(location[30].west == 25)
          nprint("The door is gone.\n");
        else
          nprint("The door is locked tight.\n");
        break;
      case 31:
        nprint("That's one immovable door.\n");
        break;
      case 20:
        nprint("The door is already ajar.\n");
        break;
      default:
        nprint("What door?");
    }
  } else
    nprint("That doesn't open.\n");
}
