#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"


int fight(int enemy, int strength) {
  int lifeline = 0;
  int hurt;
  char auxbuf[LINELENGTH];
  char *next;
  int i;
  int exhaustion;

  exhaustion = 0;
fighton:
  ourtime++;
  snooze -= 5;
  if(snooze > ourtime)
    exhaustion = CYCLE / (snooze - ourtime);
  else {
    nprint("You collapse exhausted, and he\n");
    nprint("your skull.\n");
    die();
  }
  if(snooze - ourtime < 20) {
    nprint("You look tired! I hope you're able to\n");
    nprint("fight.\n");
  }
  next = getcom(auxbuf, LINELENGTH, "<fight!>-: ", 0);
  for (i = 0; next && i < 10; i++)
    next = getword(next, words[i], -1);
  parse();
  switch (wordvalue[wordnumber]) {
    case KILL:
    case SMITE:
      if(testbit(inven, TWO_HANDED))
        hurt = rnd(70) - 2 * card(injuries, NUMOFINJURIES) - ucard(wear) - exhaustion;
      else if(testbit(inven, SWORD) || testbit(inven, BROAD))
        hurt = rnd(50) % (WEIGHT - carrying) - card(injuries, NUMOFINJURIES) - encumber - exhaustion;
      else if(testbit(inven, KNIFE) || testbit(inven, MALLET) || testbit(inven, CHAIN) || testbit(inven, MACE) || testbit(inven, HALBERD))
        hurt = rnd(15) - card(injuries, NUMOFINJURIES) - exhaustion;
      else
        hurt = rnd(7) - encumber;
      if(hurt < 5)
        switch (rnd(3)) {
          case 0:
            nprint("You swung wide and missed.\n");
            break;
          case 1:
            nprint("He checked your blow. CLASH! CLANG\n");
            break;
          case 2:
            nprint("His filthy tunic hangs by one less\n");
            nprint("thread.\n");
            break;
        }
      else if(hurt < 10) {
        switch (rnd(3)) {
          case 0:
            nprint("He's bleeding.\n");
            break;
          case 1:
            nprint("A trickle of blood runs down his face.\n");
            break;
          case 2:
            nprint("A huge purple bruise is forming on the\n");
            nprint("side of his face.\n");
            break;
        }
        lifeline++;
      } else if(hurt < 20) {
        switch (rnd(3)) {
          case 0:
            nprint("He staggers back quavering.\n");
            break;
          case 1:
            nprint("He jumps back with his hand over the\n");
            nprint("wound.\n");
            break;
          case 2:
            nprint("His shirt falls open with a swath across\n");
            nprint("the chest.\n");
            break;
        }
        lifeline += 5;
      } else if(hurt < 30) {
        switch (rnd(3)) {
        case 0:
          nprint("A bloody gash opens up on his %s side\n", (rnd(2) ? "left" : "right"));
          break;
        case 1:
          nprint("The steel bites home and scrapes along\n");
          nprint("his ribs.\n");
          break;
        case 2:
          nprint("You pierce him, and his breath hisses\n");
          nprint("through clenched teeth.\n");
          break;
        }
        lifeline += 10;
      } else if(hurt < 40) {
        switch (rnd(3)) {
          case 0:
            nprint("You smite him to the ground.\n");
            if(strength - lifeline > 20)
              nprint("But in a flurry of steel he regains his\n");
              nprint("feet!\n");
            break;
          case 1:
            nprint("The force of your blow sends him to his\n");
            nprint("knees. His arm swings lifeless at his\n");
            nprint("side.\n");
            break;
          case 2:
            nprint("Clutching his blood drenched shirt, he\n");
            nprint("collapses stunned.\n");
            break;
        }
        lifeline += 20;
      } else {
        switch (rnd(3)) {
          case 0:
            nprint("His ribs crack under your powerful\n");
            nprint("swing, flooding his lungs with blood.\n");
            break;
          case 1:
            nprint("You shatter his upheld arm in a spray\n");
            nprint("of blood. The blade continues deep into\n");
            nprint("his back, severing the spinal cord.\n");
            lifeline += 25;
            break;
          case 2:
            nprint("With a mighty lunge the steel slides in,\n");
            nprint("and gasping, he falls to the ground.\n");
            lifeline += 25;
            break;
        }
        lifeline += 30;
      }
      break;
    case BACK:
      if(enemy == DARK && lifeline > strength * 0.33) {
        nprint("He throws you back against the rock and\n");
        nprint("pummels your face.\n");
        if(testbit(inven, AMULET) || testbit(wear, AMULET)) {
          nprint("Lifting the amulet from you, ");
          if(testbit(inven, MEDALION) || testbit(wear, MEDALION)) {
            nprint("his power\n");
            nprint("grows and the walls of the earth\n");
            nprint("tremble. When he touches the medallion,\n");
            nprint("your chest explodes and the foundations\n");
            nprint("of the earth collapse.\n");
            nprint("The planet is consumed by darkness.\n");
            die();
          }
          if(testbit(inven, AMULET)) {
            clearbit(inven, AMULET);
            carrying -= objwt[AMULET];
            encumber -= objcumber[AMULET];
          } else
            clearbit(wear, AMULET);
          nprint("he flees\n");
          nprint("down the dark caverns.\n");
          clearbit(location[position].objects, DARK);
          injuries[SKULL] = 1;
          followfight = ourtime;
          return (0);
        } else {
          nprint("I'm afraid you have been killed.\n");
          die();
        }
      } else {
        nprint("You escape stunned and disoriented from\n");
        nprint("the fight. A victorious bellow echoes\n");
        nprint("from the battlescene.\n");
        if(back && position != back)
          moveplayer(back, BACK);
        else if(ahead && position != ahead)
          moveplayer(ahead, AHEAD);
        else if(left && position != left)
          moveplayer(left, LEFT);
        else if(right && position != right)
          moveplayer(right, RIGHT);
        else
          moveplayer(location[position].down, AHEAD);
        return (0);
      }
    case SHOOT:
      if(testbit(inven, LASER)) {
        if(strength - lifeline <= 50) {
          nprint("The %s took a direct hit!\n", objsht[enemy]);
          lifeline += 50;
        } else {
          nprint("With his bare hand he deflects the laser\n");
          nprint("blast and whips the pistol from you!\n");
          clearbit(inven, LASER);
          setbit(location[position].objects, LASER);
          carrying -= objwt[LASER];
          encumber -= objcumber[LASER];
        }
      } else
        nprint("Unfortunately, you don't have a blaster\n");
        nprint("handy.\n");
      break;
    case DROP:
    case DRAW:
      cypher();
      ourtime--;
      break;
    default:
      nprint("You don't have a chance; he is too\n");
      nprint("quick.\n");
      break;
  }
  if(lifeline >= strength) {
    nprint("You have killed the %s.\n", objsht[enemy]);
    if(enemy == ELF || enemy == DARK) {
      nprint("A watery black smoke consumes his body\n");
      nprint("and then vanishes with a peal of\n");
      nprint("thunder!\n");
    }
    clearbit(location[position].objects, enemy);
    power += 2;
    notes[JINXED]++;
    return (0);
  }
  nprint("He attacks...\n");
  /* Some embellishments. */
  hurt = rnd(NUMOFINJURIES) - (testbit(inven, SHIELD) != 0) - (testbit(wear, MAIL) != 0) - (testbit(wear, HELM) != 0);
  hurt += (testbit(wear, AMULET) != 0) + (testbit(wear, MEDALION) != 0) + (testbit(wear, TALISMAN) != 0);
  hurt = hurt < 0 ? 0 : hurt;
  hurt = hurt >= NUMOFINJURIES ? NUMOFINJURIES - 1 : hurt;
  if(!injuries[hurt]) {
    injuries[hurt] = 1;
    nprint("I'm afraid you have suffered %s.\n", ouch[hurt]);
  } else
    nprint("You emerge unscathed.\n");
  if(injuries[SKULL] && injuries[INCISE] && injuries[NECK]) {
    nprint("I'm afraid you have suffered fatal\n");
    nprint("injuries.\n");
    die();
  }
  goto fighton;
}
