#include <os.h>
#include "screen.h"
#include "charmap.h"
#include "console.h"

int col=0;
int line=0;

void dispc(unsigned char* buf, char c, int ret, int trsp) {
  int stop = 0;

  if(c == 0x0A) {
    if(ret) { 
      col = 0;
      line ++;
    } else {
      putBufChar(getScreen(), col*CHAR_WIDTH, line*CHAR_HEIGHT, ' ', trsp);
      col++;
    }
  } else if(c == 0x09) {
    int j, spaces = col + 1;
    spaces %= 8;
    spaces = 9 - spaces;
    if(col+spaces <= 40)
      for(j=0;j<spaces;j++)
        dspc(' ');
  } else if(c == 0x08) {
    col--;
    dspc(' ');
    col--;
  } else {
    putBufChar(getScreen(), col*CHAR_WIDTH, line*CHAR_HEIGHT, c, trsp);
    col++;
  }
  if(col >= MAX_COL) {
    if(!ret) stop=1;
    else {
      col = 0;
      line ++;
    }
  }
  if(line >= MAX_LGN) {
    line--;
    scroll(buf);
  }
}

void dspc(char c) {
  dispc(getScreen(), c, 1, 0);
}

static void ui2a(unsigned int num, unsigned int base, int uc,char * bf) {
  int n=0;
  unsigned int d=1;
  while(num/d >= base)
    d*=base;
  while(d!=0) {
    int dgt = num / d;
    num%= d;
    d/=base;
    if(n || dgt>0 || d==0) {
      *bf++ = dgt+(dgt<10 ? '0' : (uc ? 'A' : 'a')-10);
      ++n;
    }
  }
  *bf=0;
}

static void i2a (int num, char * bf) {
  if(num<0) {
    num=-num;
    *bf++ = '-';
  }
  ui2a(num,10,0,bf);
}

static int a2d(char ch) {
  if(ch>='0' && ch<='9') 
    return ch-'0';
  else if(ch>='a' && ch<='f')
    return ch-'a'+10;
  else if(ch>='A' && ch<='F')
    return ch-'A'+10;
  else return -1;
}

static char a2i(char ch, char** src,int base,int* nump) {
  char* p= *src;
  int num=0;
  int digit;
  while((digit=a2d(ch))>=0) {
    if(digit>base) break;
    num=num*base+digit;
    ch=*p++;
  }
  *src=p;
  *nump=num;
  return ch;
}

static void putchw(int n, char z, char* bf) {
  char fc=z? '0' : ' ';
  char ch;
  char* p=bf;
  while(*p++ && n > 0) n--;
  while(n-- > 0) dspc(fc);
  while((ch= *bf++)) dspc(ch);
}

void npformat(char *fmt, va_list va) {
  char bf[12];
  char ch;

  while((ch=*(fmt++))) {
    if(ch!='%') dspc(ch);
    else {
      char lz=0;
      int w=0;
      ch=*(fmt++);
      if(ch=='0') {
        ch=*(fmt++);
        lz=1;
      }
      if(ch>='0' && ch<='9') {
        ch=a2i(ch,&fmt,10,&w);
      }
      switch(ch) {
        case 0:
          goto abort;
        case 'u': {
          ui2a(va_arg(va, unsigned int),10,0,bf);
          putchw(w,lz,bf);
          break;
        }
        case 'd': {
          i2a(va_arg(va, int),bf);
          putchw(w,lz,bf);
          break;
        }
        case 'x': case 'X':
          ui2a(va_arg(va, unsigned int),16,(ch=='X'),bf);
          putchw(w,lz,bf);
          break;
        case 'c': 
          dspc((char)(va_arg(va, int)));
          break;
        case 's':
          putchw(w,0,va_arg(va, char*));
          break;
        case '%':
          dspc(ch);
        default:
          break;
      }
    }
  }
  abort:;
}

void nprint(char *fmt, ...) {
  va_list va;
  va_start(va,fmt);
  npformat(fmt,va);
  va_end(va);
}
