#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"


int cypher() {
  int n;
  int junk;
  int lflag = -1;
  char buffer[10];
  char *filename, *rfilename;
  size_t filename_len;

  while (wordnumber <= wordcount) {
    if(wordtype[wordnumber] != VERB && !(wordtype[wordnumber] == OBJECT && wordvalue[wordnumber] == KNIFE)) {
      nprint("%s: How's that?\n", (wordnumber == wordcount) ? words[0] : words[wordnumber]);
      return (-1);
    }
    switch (wordvalue[wordnumber]) {
      case AUXVERB:
        wordnumber++;
        continue;
      case UP:
        if(location[position].access || wiz || tempwiz) {
          if(!location[position].access)
            nprint("Zap! A gust of wind lifts you up.\n");
          if(!moveplayer(location[position].up, AHEAD))
            return (-1);
        } else {
          nprint("There is no way up.\n");
          return (-1);
        }
        lflag = 0;
        break;
      case DOWN:
        if(!moveplayer(location[position].down, AHEAD))
          return (-1);
        lflag = 0;
        break;
      case LEFT:
        if(!moveplayer(left, LEFT))
          return (-1);
        lflag = 0;
        break;
      case RIGHT:
        if(!moveplayer(right, RIGHT))
          return (-1);
        lflag = 0;
        break;
      case AHEAD:
        if(!moveplayer(ahead, AHEAD))
          return (-1);
        lflag = 0;
        break;
      case BACK:
        if(!moveplayer(back, BACK))
          return (-1);
        lflag = 0;
       break;
      case SHOOT:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(location[position].objects, n) && objsht[n]) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = shoot();
            }
          if(!things)
            nprint("Nothing to shoot at!\n");
          wordnumber++;
          wordnumber++;
        } else
          shoot();
        break;
      case TAKE:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(location[position].objects, n) && objsht[n]) {
              things++;
              wordvalue[wordnumber + 1] = n;
              switch(n) {
                case BATHGOD:
                  wordvalue[wordnumber + 1] = NORMGOD;
                  /* FALLTHROUGH */
                case NORMGOD:
                case AMULET:
                case MEDALION:
                case TALISMAN:
                case MAN:
                case TIMER:
                case NATIVE:
                  wordtype[wordnumber + 1] = NOUNS;
                  break;
                default:
                  wordtype[wordnumber + 1] = OBJECT;
              }
              wordnumber = take(location[position].objects);
            }
          wordnumber++;
          wordnumber++;
          if(!things)
            nprint("Nothing to take!\n");
        } else
          take(location[position].objects);
        break;
      case DROP:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(inven, n)) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = drop("Dropped");
            }
          wordnumber++;
          wordnumber++;
          if(!things)
            nprint("Nothing to drop!\n");
        } else
          drop("Dropped");
        break;
      case KICK:
      case THROW:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things, wv;
          things = 0;
          wv = wordvalue[wordnumber];
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(inven, n) || (testbit(location[position].objects, n) && objsht[n])) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = throw(wordvalue[wordnumber] == KICK ? "Kicked" : "Thrown");
            }
          wordnumber += 2;
          if(!things)
            nprint("Nothing to %s!\n", wv == KICK ? "kick" : "throw");
        } else
          throw(wordvalue[wordnumber] == KICK ? "Kicked" : "Thrown");
        break;
      case TAKEOFF:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(wear, n)) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = takeoff();
            }
          wordnumber += 2;
          if(!things)
            nprint("Nothing to take off!\n");
        } else
          takeoff();
        break;
      case DRAW:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(wear, n)) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = draw();
            }
          wordnumber += 2;
          if(!things)
            nprint("Nothing to draw!\n");
        } else
          draw();
        break;
      case PUTON:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(location[position].objects, n) && objsht[n]) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = puton();
            }
          wordnumber += 2;
          if(!things)
            nprint("Nothing to put on!\n");
        } else
          puton();
        break;
      case WEARIT:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(inven, n)) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = wearit();
            }
          wordnumber += 2;
          if(!things)
            nprint("Nothing to wear!\n");
        } else
          wearit();
        break;
      case EAT:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(inven, n)) {
              things++;
              wordvalue[wordnumber + 1] = n;
              wordnumber = eat();
            }
          wordnumber += 2;
          if(!things)
            nprint("Nothing to eat!\n");
        } else
          eat();
        break;
      case PUT:
        put();
        break;
      case INVEN:
        if(ucard(inven)) {
          nprint("You are holding:\n");
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(inven, n))
              nprint("\t%s\n", objsht[n]);
          if(WEIGHT == 0)
            nprint("\n= %d kilogram%s (can't lift any weight%s)\n", carrying, (carrying == 1 ? "." : "s."), (carrying ? " or move with what you have" : ""));
          else
            nprint("\n= %d kilogram%s (%d%%)\n", carrying, (carrying == 1 ? "." : "s."), carrying * 100 / WEIGHT);
          if(CUMBER == 0)
            nprint("Your arms can't pick anything up.\n");
          else
            nprint("Your arms are %d%% full.\n", encumber * 100 / CUMBER);
        } else
          nprint("You aren't carrying anything.\n");
        if(ucard(wear)) {
          nprint("You are wearing:\n");
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(wear, n))
              nprint("\t%s\n", objsht[n]);
        } else
          nprint("You are stark naked.\n");
        if(card(injuries, NUMOFINJURIES)) {
          nprint("You have suffered:\n");
          for (n = 0; n < NUMOFINJURIES; n++)
            if(injuries[n])
              nprint("\t%s\n", ouch[n]);
          nprint("\nYou can still carry up to %d kilogram%s\n", WEIGHT, (WEIGHT == 1 ? "." : "s."));
        } else
          nprint("You are in perfect health.\n");
        wordnumber++;
        break;
      case USE:
        lflag = use();
        break;
      case OPEN:
        if(wordnumber < wordcount && wordvalue[wordnumber + 1] == EVERYTHING) {
          int things;
          things = 0;
          for (n = 0; n < NUMOFOBJECTS; n++)
            if(testbit(inven, n)) {
              things++;
              wordvalue[wordnumber + 1] = n;
              dooropen();
            }
          wordnumber += 2;
          if(!things)
            nprint("Nothing to open!\n");
        } else
          dooropen();
        break;
      case LOOK:
        if(!notes[CANTSEE] || testbit(inven, LAMPON) || testbit(location[position].objects, LAMPON) || matchlight) {
          beenthere[position] = 2;
          writedes();
          printobjs();
          if(matchlight) {
            nprint("Your match splutters out.\n");
            matchlight = 0;
          }
        } else
          nprint("I can't see anything.\n");
        return (-1);
        break;
      case SU:
        if(wiz || tempwiz) {
          nprint("\nRoom (was %d) = ", position);
          fgetstr(buffer, 10);
          if(*buffer != '\n')
            sscanf(buffer, "%d", &position);
          nprint("Time (was %d) = ", ourtime);
          fgetstr(buffer, 10);
          if(*buffer != '\n')
            sscanf(buffer, "%d", &ourtime);
          nprint("Fuel (was %d) = ", fuel);
          fgetstr(buffer, 10);
          if(*buffer != '\n')
            sscanf(buffer, "%d", &fuel);
          nprint("Torps (was %d) = ", torps);
          fgetstr(buffer, 10);
          if(*buffer != '\n')
            sscanf(buffer, "%d", &torps);
          nprint("CUMBER (was %d) = ", CUMBER);
          fgetstr(buffer, 10);
          if(*buffer != '\n')
            sscanf(buffer, "%d", &CUMBER);
          nprint("WEIGHT (was %d) = ", WEIGHT);
          fgetstr(buffer, 10);
          if(*buffer != '\n')
            sscanf(buffer, "%d", &WEIGHT);
          nprint("Clock (was %d) = ", ourclock);
          fgetstr(buffer, 10);
          if(*buffer != '\n')
            sscanf(buffer, "%d", &ourclock);
          nprint("Wizard (was %d, %d) = ", wiz, tempwiz);
          fgetstr(buffer, 10);
          if(*buffer != '\n') {
            sscanf(buffer, "%d", &junk);
            if(!junk)
              tempwiz = wiz = 0;
          }
          nprint("\nDONE.\n");
          return (0);
        } else
          nprint("You aren't a wizard.\n");
        break;
      case SCORE:
        nprint("\tPLEASURE\tPOWER\t\tEGO\n");
        nprint("\t%3d\t\t%3d\t\t%3d\n\n", pleasure, power, ego);
        nprint("This gives you the rating of %s\n", rate());
        nprint("in %d turns.\n", ourtime);
        nprint("You have visited %d out of %d rooms\n", card(beenthere, NUMOFROOMS), NUMOFROOMS);
        nprint("this run (%d%%).\n", card(beenthere, NUMOFROOMS) * 100 / NUMOFROOMS);
        break;
      case KNIFE:
      case KILL:
        murder();
        break;
      case UNDRESS:
      case RAVAGE:
        ravage();
        break;
    /*case SAVE:
        nprint("\nSave file name (default %s): ", DEFAULT_SAVE_FILE);
        filename = fgetln(stdin, &filename_len);
        if(filename_len == 0 || (filename_len == 1 && filename[0] == '\n'))
        rfilename = save_file_name(DEFAULT_SAVE_FILE, strlen(DEFAULT_SAVE_FILE));
        else {
          if(filename[filename_len - 1] == '\n')
            filename_len--;
          rfilename = save_file_name(filename, filename_len);
        }
        save(rfilename);
        free(rfilename);
        break;*/
      case VERBOSE:
        verbose = 1;
        nprint("[Maximum verbosity]\n");
        break;
      case BRIEF:
        verbose = 0;
        nprint("[Standard verbosity]\n");
        break;
      case FOLLOW:
        lflag = follow();
        break;
      case GIVE:
        give();
        break;
      case KISS:
        kiss();
        break;
      case LOVE:
        love();
        break;
      case RIDE:
        lflag = ride();
        break;
      case DRIVE:
        lflag = drive();
        break;
      case LIGHT:
        light();
        break;
      case LAUNCH:
        if(!launch())
          return (-1);
        else
          lflag = 0;
        break;
      case LANDIT:
        if(!land())
          return (-1);
        else
          lflag = 0;
        break;
      case TIME:
        chime();
        break;
      case SLEEP:
        zzz();
        break;
      case DIG:
        dig();
        break;
      case JUMP:
        lflag = jump();
        break;
      case BURY:
        bury();
        break;
      case SWIM:
        nprint("Surf's up!\n");
        break;
      case DRINK:
        drink();
        break;
      case QUIT:
        die();
        return 1;
        break;
      default:
        nprint("How's that?\n");
        return (-1);
        break;
    }
    if(wordnumber < wordcount && *words[wordnumber++] == ',')
      continue;
    else
      return (lflag);
  }
  return (lflag);
}
