#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"


void writedes() {
  int compass;
  const char *p;
  int c;

  nprint("%s\n", location[position].name);
  if (beenthere[position] < ROOMDESC || verbose) {
    compass = NORTH;
    for (p = location[position].desc; (c = *p++) != 0;)
      if (c != '-' && c != '*' && c != '+') {
        if (c == '=')
          dspc('-');
        else
          dspc(c);
      } else {
        if (c != '*')
          nprint("%s",truedirec(compass, c));
        compass++;
      }
  }
}

void printobjs() {
  unsigned int *p = location[position].objects;
  int     n;

  nprint("\n");
  for (n = 0; n < NUMOFOBJECTS; n++)
    if (testbit(p, n) && objdes[n])
      nprint("%s\n",objdes[n]);
}

void whichway(struct room here) {
  switch (direction) {
    case NORTH:
      left = here.west;
      right = here.east;
      ahead = here.north;
      back = here.south;
      break;
    case SOUTH:
      left = here.east;
      right = here.west;
      ahead = here.south;
      back = here.north;
      break;
    case EAST:
      left = here.north;
      right = here.south;
      ahead = here.east;
      back = here.west;
      break;
    case WEST:
      left = here.south;
      right = here.north;
      ahead = here.west;
      back = here.east;
      break;
  }
}

const char *truedirec(int way, char option) {
  switch (way) {
    case NORTH:
      switch (direction) {
        case NORTH:
          return ("ahead");
        case SOUTH:
          return (option == '+' ? "behind you" : "back");
        case EAST:
          return ("left");
        case WEST:
          return ("right");
      }
    case SOUTH:
      switch (direction) {
        case NORTH:
          return (option == '+' ? "behind you" : "back");
        case SOUTH:
          return ("ahead");
        case EAST:
          return ("right");
        case WEST:
          return ("left");
      }
    case EAST:
      switch (direction) {
        case NORTH:
          return ("right");
        case SOUTH:
          return ("left");
        case EAST:
          return ("ahead");
        case WEST:
          return (option == '+' ? "behind you" : "back");
      }
    case WEST:
      switch (direction) {
        case NORTH:
          return ("left");
        case SOUTH:
          return ("right");
        case EAST:
          return (option == '+' ? "behind you" : "back");
        case WEST:
          return ("ahead");
      }
    default:
      nprint("Error: room %d.  More than four directions wanted.", position);
      return ("!!");
  }
}

void newway(int thisway) {
  switch (direction) {
    case NORTH:
      switch (thisway) {
        case LEFT:
          direction = WEST;
          break;
        case RIGHT:
          direction = EAST;
          break;
        case BACK:
          direction = SOUTH;
          break;
      }
      break;
    case SOUTH:
      switch (thisway) {
        case LEFT:
          direction = EAST;
          break;
        case RIGHT:
          direction = WEST;
          break;
        case BACK:
          direction = NORTH;
          break;
      }
      break;
    case EAST:
      switch (thisway) {
        case LEFT:
          direction = NORTH;
          break;
        case RIGHT:
          direction = SOUTH;
          break;
        case BACK:
          direction = WEST;
          break;
      }
      break;
    case WEST:
      switch (thisway) {
        case LEFT:
          direction = SOUTH;
          break;
        case RIGHT:
          direction = NORTH;
          break;
        case BACK:
          direction = EAST;
          break;
      }
      break;
  }
}
